//+------------------------------------------------------------------
//|                                             MACD forr AUDUSD.mq5 
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#include <Trade\Trade.mqh>

input int    FastMACDPeriod   = 12;
input int    SlowMACDPeriod   = 26;
input int    SignalMACDPeriod =  9;
input double StopLossPips     = 40;
input double RiskRewardRatio  = 3.0;
input int    StartHour        = 5;
input int    EndingHour       = 15;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   return(0);
}
void OnDeinit(const int reason)
{
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing  0
#define _doOpenBuy  1
#define _doOpenSell 2

void OnTick()
{
   if(PositionSelect(_Symbol)) ManageOpened();
   else                        CheckForOpen();
}

//
//
//
//
//

void ManageOpened()
{
}
void CheckForOpen()
{
   int doWhat = checkEntry(); if (doWhat==_doNothing) return;

   //
   //
   //
   //
   //
   
      int    digits = (int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
      double point  = (double)SymbolInfoDouble(_Symbol,SYMBOL_POINT);
      double pip    = point; if (digits==3 || digits==5) pip = point*10.0;

      //
      //
      //
      //
      //
            
                  
      ENUM_ORDER_TYPE signal;
      if (doWhat==_doOpenBuy)  signal = ORDER_TYPE_BUY;
      if (doWhat==_doOpenSell) signal = ORDER_TYPE_SELL;
      if (TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
      {
         double sl,tp,bp;
            if (doWhat==_doOpenBuy)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_ASK);
               sl = bp-StopLossPips*pip;
               tp = bp+StopLossPips*pip*RiskRewardRatio;
            }
            if (doWhat==_doOpenSell)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_BID);
               sl = bp+StopLossPips*pip;
               tp = bp-StopLossPips*pip*RiskRewardRatio;
            }
      
            //
            //
            //
            //
            //
            
         CTrade trade;
                trade.PositionOpen(_Symbol,signal,0.1,SymbolInfoDouble(_Symbol,signal==ORDER_TYPE_SELL ? SYMBOL_BID:SYMBOL_ASK),sl,tp);
      }
}

//
//
//
//
//

int checkEntry()
{
   if (_Symbol != "AUDUSD")     return(_doNothing);
   if (_Period != PERIOD_D1)    return(_doNothing);
   if (PositionSelect(_Symbol)) return(_doNothing);

   //
   //
   //
   //
   //
   
   MqlDateTime ct; TimeToStruct(TimeCurrent(),ct);
   static int macdHandle = 0;
          if (macdHandle == 0) macdHandle = iMACD(_Symbol,_Period,FastMACDPeriod,SlowMACDPeriod,SignalMACDPeriod,PRICE_CLOSE);
          if (macdHandle == INVALID_HANDLE) return(_doNothing);
          
          //
          //
          //
          //
          //
          
          double macdMain[3],macdSign[3];
          bool allowedHours =  (ct.hour>StartHour && ct.hour<EndingHour);
               if (!allowedHours)                                      return(_doNothing);
               if (CopyBuffer(macdHandle,0,0,3,macdMain)!=3)           return(_doNothing);
               if (CopyBuffer(macdHandle,1,0,3,macdSign)!=3)           return(_doNothing);
               if (macdMain[2]<macdSign[2] && macdMain[1]>macdSign[1]) return(_doOpenBuy);
               if (macdMain[2]>macdSign[2] && macdMain[1]<macdSign[1]) return(_doOpenSell);
                                                                       return(_doNothing);
}